#!/usr/local/bin/perl

use warnings;
use strict;

my $line_points = 0;
my $avg;
my $current_line;

if (!($ARGV[0])) { print "usage: perl splitter.pl logfile.txt <->[x|y] [value]\n"; exit; }

my $logfile = shift @ARGV;
 
open(LOGFILE, "<$logfile") || die "can't open $logfile!!\n";

my $direction;
my $axis;

$_ = shift @ARGV;
if(m/-/)  {
	$direction = 'lt';
} else {
	$direction = 'gt';
}
if(m/(x|X)/) {
	$axis = 'x';
} else {
	$axis = 'y';
}
my $value = shift @ARGV;

print 'Axis: ' . $axis . '   Direction: ' . $direction . '   Value: ' . $value . '\n';

my $do_output = 0;

while (<LOGFILE>) {
    if (m/ start new map line/) {
    	if($line_points > 0)  {
    		$avg /= $line_points;
    		if($direction eq 'gt')  {
    			if($avg > $value)  {
    				$do_output = 1;
    				print "$avg greater than $value\n";
    			}
    		} else {
    			if($avg < $value)  {
    				$do_output = 1;
    				print "$avg less than $value\n";
    			}
    		}
    		if($do_output)  {
    			print $current_line;
    			$do_output = 0;
    		}
    		$line_points = 0;
    		$avg = 0;
	   	}
	   	$current_line = $_;
    } elsif (m/Your location is (.*?\.\d{2}), (.*?\.\d{2}), (.*?\.\d{2}).  Your/) {
        my $x = $1;
        my $y = $3;
        my $z = $2;

        $x =~ s/,//g;
        $y =~ s/,//g;
        $z =~ s/,//g;
        
        
        #if ($x < 0) {
        #    $x = abs($x);  #  poor mans number inversion (changing neg numbers to pos, and vice versa)
        #} elsif ($x > 0) {
        #    $x = (0 - abs($x));
        #}
		
		if($axis eq 'x') {
			$avg += $x;
		} else {
			$avg += $y;
		}
        $line_points++;

        $current_line .= $_;
    }
}

